'SETUP.BAS - create vertical scrolling demo
'Run this program first to create .gfx files for DEMO.BAS

SCREEN 13
'******************************************
'start of .pcx loader (320/200 - 256 color)
'******************************************
CLS
TYPE TH
  MAN AS STRING * 1
  VER AS STRING * 1
  ENC AS STRING * 1
  BIT AS STRING * 1
  XLS AS INTEGER
  YLS AS INTEGER
  XMS AS INTEGER
  YMS AS INTEGER
  HRE AS INTEGER
  VRE AS INTEGER
  COL AS STRING * 48
  RES AS STRING * 1
  PLA AS STRING * 1
  BYT AS INTEGER
  pal AS INTEGER
  FIL AS STRING * 58
END TYPE

DIM H AS TH
DIM DAT AS STRING * 1

f$(1) = "Ball1.pcx"     '*******************
f$(2) = "Ball2.pcx"     ' 3 pcx pics
f$(3) = "ball3.pcx"     '*******************

ab(1) = 12: bc(1) = 172  '****************************
ab(2) = 21: bc(2) = 173  'values for clipping pcx pics
ab(3) = 24: bc(3) = 176  '****************************

DO
  nb = nb + 1           '1, 2, and 3
  FILE$ = f$(nb)        'Ball_.pcx

  OPEN FILE$ FOR BINARY AS #1
    GET #1, 1, H
    C = 1
    y = 0: x = 0
    WHILE C <= 64000
    GET #1, , DAT
    IF ASC(DAT) > 192 AND ASC(DAT) <= 255 THEN
      LPS = ASC(DAT) - 192
      GET #1, , DAT
      VALUE = ASC(DAT)
        WHILE LPS > 0
          PSET (x, y), VALUE
          IF x = 319 THEN x = 0: y = y + 1 ELSE x = x + 1
          C = C + 1
          LPS = LPS - 1
        WEND
    ELSE
      VALUE = ASC(DAT)
      PSET (x, y), VALUE
      IF x = 319 THEN x = 0: y = y + 1 ELSE x = x + 1
      C = C + 1
    END IF
  WEND
  GET #1, LOF(1) - 768, DAT
  FOR LPS = 0 TO 255
    GET #1, , DAT
    a = INT(ASC(DAT) / 4)
    GET #1, , DAT
    b = INT(ASC(DAT) / 4)
    GET #1, , DAT
    C = INT(ASC(DAT) / 4)
    SLOT = LPS
    R& = a
    G& = b
    b& = C
    G& = G& * 256
    b& = b& * 65536
    RGB& = R& + G& + b&
    PALETTE SLOT, RGB&
  NEXT LPS
  CLOSE                                         'End of .pcx loader
  
   '************************************
   'bsave 61 (8 x 320 pixel) size clips
   '************************************
   DIM gph%(1281)                               '1281 is GET size for clip
   FOR y = ab(nb) TO bc(nb) STEP 8
     num = num + 1
     GET (0, y)-(319, (y + 8) - 1), gph%        'Clip 8 x 200 pic
     f$ = "Balpic" + LTRIM$(STR$(num)) + ".gfx" 'name Balpic_.gfx
     DEF SEG = VARSEG(gph%(0))
     BSAVE f$, VARPTR(gph%(0)), 1281 * 2        'bsave as Balpic_.gfx
   NEXT y

LOOP UNTIL nb = 3                               'loop to next .pcx pic

'***********************************
'save 256 color palette to .dat file
'***********************************
OPEN "Balpal.dat" FOR OUTPUT AS #1:
FOR x = 0 TO 255
  OUT &H3C7, x
  redvalue = INP(&H3C9): dtt = redvalue: WRITE #1, dtt
  GreenValue = INP(&H3C9): dtt = GreenValue: WRITE #1, dtt
  BlueValue = INP(&H3C9): dtt = BlueValue: WRITE #1, dtt
NEXT x
CLOSE

'**************************************************************************
'create final bsaved .gfx files
'**************************************************************************
 CLEAR
 DIM gph2%(32766)
 CLS
 num = 0: a = 1: b = 24: y = 8                  'b=24... 24 (320x8) clips
DO
  '*********************************************************
  'bload and put 24 (320x8) clips to create (320x192) image
  '*********************************************************
  FOR num2 = a TO b
    f$ = "Balpic" + LTRIM$(STR$(num2)) + ".gfx"
    DEF SEG = VARSEG(gph2%(0))
    BLOAD f$, VARPTR(gph2%(0))
    PUT (0, y), gph2%, PSET
    y = y + 8
  NEXT num2
 
  '****************************************************
  'bsave 38 (320x192) images from screen to Balbsv_.gfx
  '****************************************************
  num = num + 1
  GET (0, 8)-(319, 199), gph2%                   'GET (320x192) image
  f$ = "Balbsv" + LTRIM$(STR$(num)) + ".gfx"     'Balbsv_.gfx
  DEF SEG = VARSEG(gph2%(0))
  BSAVE f$, VARPTR(gph2%(0)), 64000              'bsave Balbsv_.gfx
  y = 8: a = a + 1: b = b + 1
LOOP UNTIL b = 62                                '62 - 24 = 38...
                                                 '...38 (320x192) images saved

'**************************************************************
'Delete all 61 (8 x 200) balpic_.gfx files (not needed anymore)
'**************************************************************
FOR x = 1 TO 61
  f$ = "Balpic" + LTRIM$(STR$(x)) + ".gfx"
  KILL f$
NEXT x

CLS
LOCATE 12, 2
PRINT "Open and run DEMO.BAS to start demo"





